diff --git a/bin/Makefile b/bin/Makefile
index 0ccbf5f3d175..324251299d75 100644
--- a/bin/Makefile
+++ b/bin/Makefile
@@ -52,6 +52,7 @@ SUBDIR.${MK_CHERI}+=	cheri_pthreads
 SUBDIR.${MK_CHERI}+=	helloworld
 SUBDIR.${MK_CHERI}+=	helloworld_cxx
 SUBDIR.${MK_CHERI}+=	helloworld_static
+SUBDIR.${MK_CHERI}+=	cheri_bench_malloc
 
 # Consumers of libhelloworld
 SUBDIR.${MK_LIBCHERI}+=	cheri_helloworld
diff --git a/bin/cheri_bench_malloc/Makefile b/bin/cheri_bench_malloc/Makefile
new file mode 100644
index 000000000000..3049aafbb298
--- /dev/null
+++ b/bin/cheri_bench_malloc/Makefile
@@ -0,0 +1,15 @@
+# $FreeBSD$
+
+.include <src.opts.mk>
+
+NEED_CHERI=pure
+LIBADD+=pthread
+LIBADD+=cheri_caprevoke
+
+PROG=  cheri_bench_malloc
+MAN=
+SRCS=  main.c \
+       capdirty.c \
+       malloc_comb.c
+
+.include <bsd.prog.mk>
diff --git a/bin/cheri_bench_malloc/capdirty.c b/bin/cheri_bench_malloc/capdirty.c
new file mode 100644
index 000000000000..8290540f02b3
--- /dev/null
+++ b/bin/cheri_bench_malloc/capdirty.c
@@ -0,0 +1,121 @@
+/*
+ * A benchmark for stressing the capdirty tracking.
+ *
+ * Optional arguments:
+ *
+ *   flavor: specify as OR of:
+ *     0x01 - read from each page
+ *     0x02 - write data to each page
+ *     0x04 - write capabilities to each page
+ *
+ *   npgs: arena size, in pages
+ *
+ *   iters: number of rounds of resetting the arena
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+#include <sys/mman.h>
+#include <machine/param.h>
+
+#include "cheri_bench_malloc.h"
+
+int
+bench_capdirty_overhead(FILE *out, int argc, char **argv)
+{
+	int iters = 32;
+	int npgs = 512;
+  int flavor = 0x7;
+	char *arena = NULL;
+
+  if (argc > 1)
+  {
+    flavor = atoi(argv[1]);
+    argc--; argv++;
+  }
+
+  if (argc > 1)
+  {
+    npgs = atoi(argv[1]);
+    argc--; argv++;
+  }
+
+  if (argc > 1)
+  {
+    iters = atoi(argv[1]);
+    argc--; argv++;
+  }
+
+  fprintf(out, "# capdirty_overhead: flavor=0x%x npgs=%d iters=%d\n",
+          flavor, npgs, iters);
+
+	arena = mmap(arena, PAGE_SIZE*npgs, PROT_READ|PROT_WRITE,
+               MAP_ANON|MAP_PRIVATE, -1, 0);
+  if (arena == MAP_FAILED)
+  {
+    fprintf(out, "bail - initial mmap failed\n");
+    return -1;
+  }
+
+	for (int i = 0; i < iters; i++)
+  {
+		char *pagep;
+		void * __capability c = &pagep;
+		int sum = 0;
+
+		arena = mmap(arena, PAGE_SIZE*npgs,
+				PROT_READ|PROT_WRITE,
+				MAP_ANON|MAP_PRIVATE|MAP_FIXED, -1, 0);
+    if (arena == MAP_FAILED)
+    {
+      fprintf(out, "bail - remap failed\n");
+      return -2;
+    }
+
+		if (flavor & 0x1)
+    {
+			/* Read every page */
+			pagep = arena;
+			for (int j = 0; j < npgs; j++, pagep += PAGE_SIZE)
+      {
+				sum += *(int *)__builtin_assume_aligned(pagep, sizeof(int));
+			}
+      if (sum != 0)
+      {
+        fprintf(out, "bail - nonzero zero\n");
+        return -3;
+      }
+		}
+
+		if (flavor & 0x2)
+    {	
+			/* Write every page */
+			pagep = arena;
+			for (int j = 0; j < npgs; j++, pagep += PAGE_SIZE)
+      {
+				*(long *)__builtin_assume_aligned(pagep, sizeof(int))
+					= 1;
+			}
+		}
+
+		if (flavor & 0x4)
+    {
+			/* Capability-write every page */
+			pagep = arena;
+			for (int j = 0; j < npgs; j++, pagep += PAGE_SIZE)
+      {
+				*(void * __capability *)
+					__builtin_assume_aligned(pagep,
+						sizeof(void * __capability))
+					= c;
+			}
+		}
+	}
+
+	munmap(arena, PAGE_SIZE*npgs);
+  return 0;
+}
+
+
diff --git a/bin/cheri_bench_malloc/cheri_bench_malloc.h b/bin/cheri_bench_malloc/cheri_bench_malloc.h
new file mode 100644
index 000000000000..813c25778857
--- /dev/null
+++ b/bin/cheri_bench_malloc/cheri_bench_malloc.h
@@ -0,0 +1,14 @@
+#ifndef _CHERI_BENCH_MALLOC_H_
+#define _CHERI_BENCH_MALLOC_H_
+
+#include <stdio.h>
+
+typedef int (*benchfn_t)(FILE *, int, char **);
+
+/* capdirty.c */
+int bench_capdirty_overhead(FILE *, int, char **);
+
+/* malloc_comb.c */
+int bench_malloc_comb(FILE *, int, char **);
+
+#endif
diff --git a/bin/cheri_bench_malloc/main.c b/bin/cheri_bench_malloc/main.c
new file mode 100644
index 000000000000..d5d32e937c2d
--- /dev/null
+++ b/bin/cheri_bench_malloc/main.c
@@ -0,0 +1,67 @@
+#include <stdio.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "cheri_bench_malloc.h"
+
+typedef struct {
+  const char *name;
+  benchfn_t benchfn;
+} benchdesc_t;
+
+static const benchdesc_t benches[] = {
+  { "capdirty_overhead", bench_capdirty_overhead },
+  { "malloc_comb", bench_malloc_comb },
+  { NULL, NULL },
+};
+
+static void
+help(FILE *out)
+{
+  const benchdesc_t *b;
+  fprintf(out, "Possible benchmarks:\n");
+  for (b = benches; b->name != NULL; b++)
+  {
+    fprintf(out, "  %s\n", b->name);
+  }
+}
+
+int
+main(int argc, char **argv)
+{
+  int opt;
+  FILE *benchout = stdout;
+
+  while ((opt = getopt(argc, argv, "+h")) != -1)
+  {
+    switch(opt)
+    {
+    case 'h':
+      help(stdout);
+      return 0;
+    }
+  }
+
+  if (optind >= argc)
+  {
+    fprintf(stderr, "Specify benchmark\n");
+    help(stderr);
+    return 1;
+  }
+
+  const benchdesc_t *b;
+  for (b = benches; b->name != NULL; b++)
+  {
+    if (strcmp(b->name, argv[optind]) == 0)
+    {
+      break;
+    }
+  }
+  if (b == NULL)
+  {
+    fprintf(stderr, "Unknown benchmark %s\n", argv[optind]);
+    help(stderr);
+  }
+
+  return b->benchfn(benchout, argc-optind, &argv[optind]);
+}
diff --git a/bin/cheri_bench_malloc/malloc_comb.c b/bin/cheri_bench_malloc/malloc_comb.c
new file mode 100644
index 000000000000..857bccfa6146
--- /dev/null
+++ b/bin/cheri_bench_malloc/malloc_comb.c
@@ -0,0 +1,40 @@
+/*
+ * Hammer malloc with short-lived objects of a comb of sizes
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "cheri_bench_malloc.h"
+
+static const int comb_sizes[] = { 32, 512, 8192, 131072, 2097152, 33554432 };
+static const int comb_count[] = { 32,  16,    8,      4,       2,        1 };
+
+_Static_assert(sizeof(comb_sizes) == sizeof(comb_count), "bad comb sizes");
+
+int
+bench_malloc_comb(FILE *out, int argc, char **argv)
+{
+  int iters = 1024;
+
+  (void)out;
+  (void)argc;
+  (void)argv;
+
+  for(; iters > 0; iters--)
+  {
+    for(size_t cpos = 0;
+        cpos < sizeof(comb_sizes)/sizeof(comb_sizes[0]);
+        cpos++)
+    {
+      for (int op = comb_count[cpos]; op > 0; op--)
+      {
+        char *p = malloc(comb_sizes[cpos]);
+        p[0] = 1;
+        free(p);
+      }
+    }
+  }
+
+  return 0;
+}
diff --git a/bin/cheritest/Makefile b/bin/cheritest/Makefile
index 781703145272..0d7854180a77 100644
--- a/bin/cheritest/Makefile
+++ b/bin/cheritest/Makefile
@@ -31,6 +31,7 @@ CHERITEST_DIR:=	${.PARSEDIR}
 .ifdef CHERIABI_TESTS
 SRCS+=	cheritest_cheriabi.c
 SRCS+=	cheritest_cheriabi_open.c
+LIBADD+=	cheri_caprevoke
 CFLAGS+=	-DCHERIABI_TESTS
 .endif
 
@@ -82,7 +83,7 @@ WANT_CHERI=	pure
 .else
 .error Unknown cheritest variant ${PROG}
 .endif
-LIBADD= 	z
+LIBADD+= 	z
 
 LIBADD+=	xo util
 
diff --git a/bin/cheritest/cheritest.c b/bin/cheritest/cheritest.c
index af055cd6d1b2..e9c974d3e61d 100644
--- a/bin/cheritest/cheritest.c
+++ b/bin/cheritest/cheritest.c
@@ -288,6 +288,13 @@ static const struct cheri_test cheri_tests[] = {
 	  .ct_mips_exccode = T_C2E,
 	  .ct_cp2_exccode = CHERI_EXCCODE_SYSTEM_REGS },
 
+	{ .ct_name = "test_fault_cloadtags_misaligned",
+	  .ct_desc = "CLoadTags on not-cacheline-aligned address",
+	  .ct_func = test_fault_cloadtags_misaligned,
+	  .ct_flags = CT_FLAG_SIGNAL | CT_FLAG_MIPS_EXCCODE,
+	  .ct_signum = SIGBUS,
+	  .ct_mips_exccode = T_ADDR_ERR_LD, },
+
 	/*
 	 * Tests on the kernel-provided sealing capability (sealcap).
 	 */
@@ -1035,6 +1042,35 @@ static const struct cheri_test cheri_tests[] = {
 	  .ct_func = cheritest_vm_swap,
 	  .ct_check_xfail = xfail_swap_required},
 
+	{ .ct_name = "test_fault_cloadtags_mapped",
+	  .ct_desc = "CLoadTags on mapped address",
+	  .ct_func = test_cloadtags_mapped, },
+
+	{ .ct_name = "test_fault_cloadtags_unmapped",
+	  .ct_desc = "CLoadTags on unmapped address",
+	  .ct_func = test_fault_cloadtags_unmapped,
+	  .ct_flags = CT_FLAG_SIGNAL | CT_FLAG_MIPS_EXCCODE,
+	  .ct_signum = SIGSEGV,
+	  .ct_mips_exccode = T_TLB_LD_MISS, },
+
+#ifdef CHERIABI_TESTS
+	{ .ct_name = "test_caprevoke_lightly",
+	  .ct_desc = "A gentle test of capability revocation",
+	  .ct_func = test_caprevoke_lightly, },
+
+	{ .ct_name = "test_caprevoke_capdirty",
+	  .ct_desc = "Probe the interaction of revocation and capdirty",
+	  .ct_func = test_caprevoke_capdirty, },
+
+	{ .ct_name = "test_caprevoke_lib",
+	  .ct_desc = "Test libcheri_caprevoke internals",
+	  .ct_func = test_caprevoke_lib, },
+
+	{ .ct_name = "test_caprevoke_lib_fork",
+	  .ct_desc = "Test libcheri_caprevoke with fork",
+	  .ct_func = test_caprevoke_lib_fork, },
+#endif
+
 #ifdef CHERI_LIBCHERI_TESTS
 #if 0
 	/*
@@ -1157,6 +1193,10 @@ static const struct cheri_test cheri_tests[] = {
 	  .ct_desc = "Test basic handling of ptrace functionality",
 	  .ct_func = test_ptrace_basic, },
 
+	{ .ct_name = "test_aio_sival",
+	  .ct_desc = "Test pointer passing through AIO signals",
+	  .ct_func = test_aio_sival, },
+
 #ifdef CHERI_LIBCHERI_TESTS
 	/*
 	 * Test libcheri sandboxing -- and kernel sandbox unwind.
diff --git a/bin/cheritest/cheritest.h b/bin/cheritest/cheritest.h
index 6c1668b37212..b8c93e9bec9a 100644
--- a/bin/cheritest/cheritest.h
+++ b/bin/cheritest/cheritest.h
@@ -327,6 +327,7 @@ DECLARE_CHERI_TEST(test_fault_read_kr2c);
 DECLARE_CHERI_TEST(test_fault_read_kcc);
 DECLARE_CHERI_TEST(test_fault_read_kdc);
 DECLARE_CHERI_TEST(test_fault_read_epcc);
+DECLARE_CHERI_TEST(test_fault_cloadtags_misaligned);
 DECLARE_CHERI_TEST(test_nofault_ccheck_user_pass);
 
 /* cheritest_fd.c */
@@ -456,6 +457,7 @@ DECLARE_CHERI_TEST(test_sandbox_syscall);
 DECLARE_CHERI_TEST(test_sig_dfl_neq_ign);
 DECLARE_CHERI_TEST(test_sig_dfl_ign);
 DECLARE_CHERI_TEST(test_ptrace_basic);
+DECLARE_CHERI_TEST(test_aio_sival);
 
 /* cheritest_registers.c */
 DECLARE_CHERI_TEST(test_initregs_default);
@@ -493,6 +495,14 @@ DECLARE_CHERI_TEST(cheritest_vm_tag_tmpfile_private);
 DECLARE_CHERI_TEST(cheritest_vm_tag_tmpfile_private_prefault);
 DECLARE_CHERI_TEST(cheritest_vm_cow_read);
 DECLARE_CHERI_TEST(cheritest_vm_cow_write);
+#ifdef CHERIABI_TESTS
+DECLARE_CHERI_TEST(test_caprevoke_lightly);
+DECLARE_CHERI_TEST(test_caprevoke_capdirty);
+DECLARE_CHERI_TEST(test_caprevoke_lib);
+DECLARE_CHERI_TEST(test_caprevoke_lib_fork);
+#endif
+DECLARE_CHERI_TEST(test_cloadtags_mapped);
+DECLARE_CHERI_TEST(test_fault_cloadtags_unmapped);
 const char	*xfail_need_writable_tmp(const char *name);
 const char	*xfail_need_writable_non_tmpfs_tmp(const char *name);
 
diff --git a/bin/cheritest/cheritest_fault.c b/bin/cheritest/cheritest_fault.c
index e8e624cc0f2d..ec37c9fa423f 100644
--- a/bin/cheritest/cheritest_fault.c
+++ b/bin/cheritest/cheritest_fault.c
@@ -254,3 +254,15 @@ test_fault_read_epcc(const struct cheri_test *ctp __unused)
 
 	CHERI_CAP_PRINT(cheri_getepcc());
 }
+
+void
+test_fault_cloadtags_misaligned(const struct cheri_test *ctp __unused)
+{
+	uint64_t tags = 0xDEADFEED;
+	void * __capability p[20] __attribute__((aligned(512))) = { 0 } ;
+	void * __capability c = &p[1];
+
+	asm volatile ( "cloadtags %[tags], %[ptr]" : [tags]"+r"(tags) : [ptr]"r"(c) );
+
+	cheritest_success();
+}
diff --git a/bin/cheritest/cheritest_syscall.c b/bin/cheritest/cheritest_syscall.c
index de43b83c5b3a..9cdfa9acb10e 100644
--- a/bin/cheritest/cheritest_syscall.c
+++ b/bin/cheritest/cheritest_syscall.c
@@ -35,7 +35,9 @@
 #endif
 
 #include <sys/types.h>
+#include <sys/aio.h>
 #include <sys/signal.h>
+#include <sys/socket.h>
 #include <sys/sysctl.h>
 #include <sys/wait.h>
 #include <sys/time.h>
@@ -233,3 +235,54 @@ test_ptrace_basic(const struct cheri_test *ctp __unused)
 		exit(23);
 	}
 }
+
+static void
+test_aio_sival_handler(int sig __unused, siginfo_t *si, void *uc __unused)
+{
+	CHERITEST_VERIFY2(si->si_code == SI_ASYNCIO,
+		"Signal not asyncio?  code=%d\n", si->si_code);
+	CHERITEST_VERIFY2(si->si_value.sival_ptr == test_aio_sival_handler,
+		"Bad si_value; expected=%p got=%p\n",
+		test_aio_sival_handler, si->si_value.sival_ptr);
+	cheritest_success();
+}
+
+void
+test_aio_sival(const struct cheri_test *cpt __unused)
+{
+	char buf[128];
+	int pfd[2];
+	int res;
+	sigset_t sigset, osigset;
+	struct aiocb aiocb;
+	struct sigaction sa;
+
+	sa.sa_flags = SA_SIGINFO;
+	sa.sa_sigaction = &test_aio_sival_handler;
+	res = sigaction(SIGUSR1, &sa, NULL);
+	CHERITEST_VERIFY2(res == 0, "Could not install signal handler; errno=%d", errno);
+
+	res = socketpair(AF_UNIX, SOCK_STREAM, 0, pfd);
+	CHERITEST_VERIFY2(res == 0, "Could not create socketpair; errno=%d", errno);
+
+	aiocb.aio_fildes = pfd[0];
+	aiocb.aio_buf = buf;
+	aiocb.aio_nbytes = sizeof buf;
+	aiocb.aio_lio_opcode = LIO_READ;
+
+	aiocb.aio_sigevent.sigev_notify = SIGEV_SIGNAL;
+	aiocb.aio_sigevent.sigev_signo = SIGUSR1;
+	aiocb.aio_sigevent.sigev_value.sival_ptr = test_aio_sival_handler;
+
+	res = aio_read(&aiocb);
+	CHERITEST_VERIFY2(res == 0, "Could not register aio; errno=%d", errno);
+
+	sigemptyset(&sigset);
+	sigaddset(&sigset, SIGUSR1);
+	sigprocmask(SIG_BLOCK, &sigset, &osigset);
+	close(pfd[1]);
+	sigsuspend(&osigset);
+	close(pfd[0]);
+
+	cheritest_failure_errx("Test not terminated by signal handler\n");
+}
diff --git a/bin/cheritest/cheritest_vm.c b/bin/cheritest/cheritest_vm.c
index cc0ae78385b5..60775d04477f 100644
--- a/bin/cheritest/cheritest_vm.c
+++ b/bin/cheritest/cheritest_vm.c
@@ -47,6 +47,7 @@
 #include <sys/ucontext.h>
 #include <sys/wait.h>
 
+#include <sys/caprevoke.h>
 #include <sys/event.h>
 
 #include <machine/cpuregs.h>
@@ -165,7 +166,7 @@ cheritest_vm_shm_open_anon_unix_surprise(const struct cheri_test *ctp __unused)
 
 	if (pid == 0) {
 		void * __capability * map;
-		void * __capability c;
+		void * __capability crx;
 		int fd, tag;
 		struct msghdr msg = { 0 };
 		struct cmsghdr * cmsg;
@@ -192,13 +193,11 @@ cheritest_vm_shm_open_anon_unix_surprise(const struct cheri_test *ctp __unused)
 		map = CHERITEST_CHECK_SYSCALL(mmap(NULL, getpagesize(),
 						PROT_READ, MAP_SHARED, fd,
 						0));
-		c = *map;
+		crx = *map;
 
-		fprintf(stderr, "rx cap: v:%lu b:%016jx l:%016zx o:%jx\n",
-			(unsigned long)cheri_gettag(c), cheri_getbase(c),
-			cheri_getlen(c), cheri_getoffset(c));
+		CHERI_FPRINT_PTR(stderr, crx);
 
-		tag = cheri_gettag(c);
+		tag = cheri_gettag(crx);
 		CHERITEST_VERIFY2(tag == 0, "tag read");
 
 		CHERITEST_CHECK_SYSCALL(munmap(map, getpagesize()));
@@ -208,7 +207,7 @@ cheritest_vm_shm_open_anon_unix_surprise(const struct cheri_test *ctp __unused)
 		exit(tag);
 	} else {
 		void * __capability * map;
-		void * __capability c;
+		void * __capability ctx;
 		int fd, res;
 		struct msghdr msg = { 0 };
 		struct cmsghdr * cmsg;
@@ -227,12 +226,10 @@ cheritest_vm_shm_open_anon_unix_surprise(const struct cheri_test *ctp __unused)
 
 		/* Just some pointer */
 		*map = &fd;
-		c = *map;
-		CHERITEST_VERIFY2(cheri_gettag(c) != 0, "tag written");
+		ctx = *map;
+		CHERITEST_VERIFY2(cheri_gettag(ctx) != 0, "tag written");
 
-		fprintf(stderr, "tx cap: v:%lu b:%016jx l:%016zx o:%jx\n",
-			(unsigned long)cheri_gettag(c), cheri_getbase(c),
-			cheri_getlen(c), cheri_getoffset(c));
+		CHERI_FPRINT_PTR(stderr, ctx);
 
 		CHERITEST_CHECK_SYSCALL(munmap(map, getpagesize()));
 
@@ -597,3 +594,553 @@ cheritest_vm_cow_write(const struct cheri_test *ctp __unused)
 	CHERITEST_CHECK_SYSCALL(close(fd));
 	cheritest_success();
 }
+
+/*
+ * Test a mapped and unmapped invocation of cloadtags
+ */
+
+void
+test_cloadtags_mapped(const struct cheri_test *ctp __unused)
+{
+	uint64_t tags = 0;
+	void * __capability * __capability c;
+	void * __capability * p;
+
+	p = CHERITEST_CHECK_SYSCALL(mmap(0, PAGE_SIZE, PROT_READ | PROT_WRITE,
+						MAP_ANON, -1, 0));
+	c = (__cheri_tocap void * __capability * __capability) p;
+
+	CHERITEST_VERIFY2(cheri_gettag(c) != 0, "initial cap not constructed");
+
+	p[1] = c;
+	p[2] = c;
+
+	asm volatile ( "cloadtags %[tags], %[ptr]" : [tags]"+r"(tags) : [ptr]"r"(c) );
+
+	CHERITEST_VERIFY2(tags == 0x6, "incorrect result from cloadtags");
+
+	munmap(p, PAGE_SIZE);
+	cheritest_success();
+}
+
+void
+test_fault_cloadtags_unmapped(const struct cheri_test *ctp __unused)
+{
+	uint64_t tags = 0;
+	void * __capability c;
+	void * p;
+
+	p = CHERITEST_CHECK_SYSCALL(mmap(0, PAGE_SIZE, PROT_READ | PROT_WRITE,
+						MAP_ANON, -1, 0));
+	munmap(p, PAGE_SIZE);
+	c = (__cheri_tocap void * __capability) p;
+	asm volatile ( "cloadtags %[tags], %[ptr]" : [tags]"+r"(tags) : [ptr]"r"(c) );
+}
+
+/*
+ * Revocation tests
+ */
+
+#ifdef CHERIABI_TESTS
+
+static int
+check_revoked(void * __capability r)
+{
+	return ((cheri_gettag(r) == 1)
+		&& (cheri_gettype(r) == (int64_t)(-1))
+		&& (cheri_getperm(r) == 0));
+}
+
+static void
+install_kqueue_cap(int kq, void * __capability revme)
+{
+	struct kevent ike;
+
+	EV_SET(&ike, 0x2BAD, EVFILT_USER, EV_ADD|EV_ONESHOT|EV_DISABLE,
+		NOTE_FFNOP, 0, revme);
+	CHERITEST_CHECK_SYSCALL(kevent(kq, &ike, 1, NULL, 0, NULL));
+	EV_SET(&ike, 0x2BAD, EVFILT_USER, EV_KEEPUDATA,
+		NOTE_FFNOP|NOTE_TRIGGER, 0, NULL);
+	CHERITEST_CHECK_SYSCALL(kevent(kq, &ike, 1, NULL, 0, NULL));
+}
+
+static void
+check_kqueue_cap(int kq, unsigned int valid)
+{
+	struct kevent ike, oke = { 0 };
+
+	EV_SET(&ike, 0x2BAD, EVFILT_USER, EV_ENABLE|EV_KEEPUDATA,
+		NOTE_FFNOP, 0, NULL);
+	CHERITEST_CHECK_SYSCALL(kevent(kq, &ike, 1, NULL, 0, NULL));
+	CHERITEST_CHECK_SYSCALL(kevent(kq, NULL, 0, &oke, 1, NULL));
+	CHERITEST_VERIFY2(oke.ident == 0x2BAD, "Bad identifier from kqueue");
+	CHERITEST_VERIFY2(oke.filter == EVFILT_USER, "Bad filter from kqueue");
+	CHERITEST_VERIFY2(check_revoked(oke.udata) == !valid,
+				"kqueue-held cap not as expected");
+}
+
+static void
+fprintf_caprevoke_stats(FILE *f, struct caprevoke_stats crst, uint32_t cycsum)
+{
+	fprintf(f, "revoke:"
+		" einit=%" PRIu64
+		" efini=%" PRIu64
+		" psro=%" PRIu32
+		" psrw=%" PRIu32
+		" scanc=%" PRIu64
+		" psk=%" PRIu32
+		" pskf=%" PRIu32
+		" pfro=%" PRIu32
+		" pfrw=%" PRIu32
+		" prty=%" PRIu32
+		" caps=%" PRIu32
+		" crevd=%" PRIu32
+		" cnuke=%" PRIu32
+		" totc=%" PRIu32 "\n",
+		crst.epoch_init,
+		crst.epoch_fini,
+		crst.pages_scan_ro,
+		crst.pages_scan_rw,
+		crst.page_scan_cycles,
+		crst.pages_skip,
+		crst.pages_skip_fast,
+		crst.pages_faulted_ro,
+		crst.pages_faulted_rw,
+		crst.pages_retried,
+		crst.caps_found,
+		crst.caps_found_revoked,
+		crst.caps_cleared,
+		cycsum);
+}
+
+void
+test_caprevoke_lightly(const struct cheri_test *ctp __unused)
+{
+	void * __capability * __capability mb;
+	void * __capability sh;
+	const volatile struct caprevoke_info * __capability cri;
+	void * __capability revme;
+	struct caprevoke_stats crst;
+	int kq;
+	uint32_t cyc_start, cyc_end;
+
+	kq = CHERITEST_CHECK_SYSCALL(kqueue());
+	mb = CHERITEST_CHECK_SYSCALL(mmap(0, PAGE_SIZE, PROT_READ | PROT_WRITE,
+					  MAP_ANON, -1, 0));
+	CHERITEST_CHECK_SYSCALL(caprevoke_shadow(CAPREVOKE_SHADOW_NOVMMAP,
+						 mb, &sh));
+
+	CHERITEST_CHECK_SYSCALL(
+		caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+				 __DEQUALIFY_CAP(void * __capability *,&cri)));
+
+	/*
+	 * OK, armed with the shadow mapping... generate a capability to
+	 * the 0th granule of the map, spill it to the 1st granule,
+	 * stash it in the kqueue, and mark it as revoked in the shadow.
+	 */
+	revme = cheri_andperm(mb, ~CHERI_PERM_CHERIABI_VMMAP);
+	((void * __capability *)mb)[1] = revme;
+	install_kqueue_cap(kq, revme);
+
+	((uint8_t * __capability) sh)[0] = 1;
+
+	/*
+	 * First, let's see if we can shoot down just the hoarders and not
+	 * the VM.  We'll put the thing back and do a full pass momentarily.
+	 */
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_JUST_HOARDERS, 0, &crst));
+
+	check_kqueue_cap(kq, 0);
+	CHERITEST_VERIFY2(!check_revoked(mb[1]), "JUST cleared memory tag");
+
+	/* OK, full pass */
+	install_kqueue_cap(kq, revme);
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_LAST_PASS|CAPREVOKE_IGNORE_START, 0, &crst));
+	cyc_end = cheri_get_cyclecount();
+
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	CHERITEST_VERIFY2(check_revoked(mb[1]), "Memory tag persists");
+	check_kqueue_cap(kq, 0);
+
+	/* Clear the revocation bit and do that again */
+	((uint8_t * __capability) sh)[0] = 0;
+
+	/*
+	 * We don't derive exactly the same thing, to prevent CSE from
+	 * firing.  More specifically, we adjust the offset first, taking
+	 * the path through the commutation diagram that doesn't share an
+	 * edge with the derivation above.
+	 */
+	revme = cheri_andperm(mb+1, ~CHERI_PERM_CHERIABI_VMMAP);
+	CHERITEST_VERIFY2(!check_revoked(revme), "Tag clear on 2nd revme?");
+	((void * __capability *)mb)[1] = revme;
+	install_kqueue_cap(kq, revme);
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_IGNORE_START, 0, &crst));
+	cyc_end = cheri_get_cyclecount();
+
+	CHERITEST_VERIFY2(crst.epoch_fini >= crst.epoch_init + 1, "Bad epoch clock state");
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_LAST_PASS, crst.epoch_init, &crst));
+	cyc_end = cheri_get_cyclecount();
+
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	CHERITEST_VERIFY2(!check_revoked(mb[1]), "Memory tag cleared");
+
+	check_kqueue_cap(kq, 1);
+
+	munmap(mb, PAGE_SIZE);
+	close(kq);
+
+	cheritest_success();
+}
+
+void
+test_caprevoke_capdirty(const struct cheri_test *ctp __unused)
+{
+	void * __capability * __capability mb;
+	void * __capability sh;
+	const volatile struct caprevoke_info * __capability cri;
+	void * __capability revme;
+	struct caprevoke_stats crst;
+	uint32_t cyc_start, cyc_end;
+
+	mb = CHERITEST_CHECK_SYSCALL(mmap(0, PAGE_SIZE, PROT_READ | PROT_WRITE,
+					  MAP_ANON, -1, 0));
+	CHERITEST_CHECK_SYSCALL(caprevoke_shadow(CAPREVOKE_SHADOW_NOVMMAP,
+						 mb, &sh));
+
+	CHERITEST_CHECK_SYSCALL(
+		caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+				 __DEQUALIFY_CAP(void * __capability *,&cri)));
+
+	revme = cheri_andperm(cheri_csetbounds(mb, 0x10),
+			      ~CHERI_PERM_CHERIABI_VMMAP);
+	mb[0] = revme;
+
+	/* Mark the start of the arena as subject to revocation */
+	((uint8_t * __capability) sh)[0] = 1;
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_IGNORE_START, 0, &crst));
+	cyc_end = cheri_get_cyclecount();
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	CHERI_FPRINT_PTR(stderr, revme);
+	CHERI_FPRINT_PTR(stderr, mb[0]);
+
+	/* Between revocation sweeps, derive another cap and store */
+	revme = cheri_andperm(cheri_csetbounds(mb, 0x11),
+			      ~CHERI_PERM_CHERIABI_VMMAP);
+	mb[1] = revme;
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_IGNORE_START, 0, &crst));
+	cyc_end = cheri_get_cyclecount();
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	CHERI_FPRINT_PTR(stderr, revme);
+	CHERI_FPRINT_PTR(stderr, mb[0]);
+	CHERI_FPRINT_PTR(stderr, mb[1]);
+
+	/* Between revocation sweeps, derive another cap and store */
+	revme = cheri_andperm(cheri_csetbounds(mb, 0x12),
+			      ~CHERI_PERM_CHERIABI_VMMAP);
+	mb[2] = revme;
+
+	cyc_start = cheri_get_cyclecount();
+	CHERITEST_CHECK_SYSCALL(caprevoke(CAPREVOKE_LAST_PASS|CAPREVOKE_IGNORE_START, 0, &crst));
+	cyc_end = cheri_get_cyclecount();
+	fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+
+	CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+	CHERI_FPRINT_PTR(stderr, revme);
+	CHERI_FPRINT_PTR(stderr, mb[0]);
+	CHERI_FPRINT_PTR(stderr, mb[1]);
+	CHERI_FPRINT_PTR(stderr, mb[2]);
+
+	CHERITEST_VERIFY2(!check_revoked(mb), "Arena revoked");
+	CHERITEST_VERIFY2(check_revoked(revme), "Register tag cleared");
+	CHERITEST_VERIFY2(check_revoked(mb[0]), "Memory tag 0 cleared");
+	CHERITEST_VERIFY2(check_revoked(mb[1]), "Memory tag 1 cleared");
+	CHERITEST_VERIFY2(check_revoked(mb[2]), "Memory tag 2 cleared");
+
+	munmap(mb, PAGE_SIZE);
+
+	cheritest_success();
+}
+
+/*
+ * Repeatedly invoke libcheri_caprevoke logic.
+ * Using a bump the pointer allocator, repeatedly grab rand()-omly sized
+ * objects and fill them with capabilities to themselves, mark them for
+ * revocation, revoke, and validate.
+ *
+ */
+
+#include <cheri/caprevoke.h>
+
+/* Just for debugging printouts */
+#ifndef CPU_CHERI
+#define CPU_CHERI
+#include <machine/pte.h>
+#include <machine/vmparam.h>
+#undef CPU_CHERI
+#else
+#include <machine/pte.h>
+#include <machine/vmparam.h>
+#endif
+
+static void
+test_caprevoke_lib_init(
+	size_t bigblock_caps,
+	void * __capability * __capability * obigblock,
+	void * __capability * oshadow,
+	const volatile struct caprevoke_info * __capability * ocri
+)
+{
+	void * __capability * __capability bigblock;
+
+	bigblock = CHERITEST_CHECK_SYSCALL(
+			mmap(0, bigblock_caps * sizeof(void * __capability),
+				PROT_READ | PROT_WRITE,
+				MAP_ANON, -1, 0));
+
+	for (size_t ix = 0; ix < bigblock_caps; ix++) {
+		/* Create self-referential VMMAP-free capabilities */
+
+		bigblock[ix] = cheri_andperm(
+				cheri_csetbounds(&bigblock[ix], 16),
+				~CHERI_PERM_CHERIABI_VMMAP);
+	}
+	*obigblock = bigblock;
+
+	CHERITEST_CHECK_SYSCALL(
+		caprevoke_shadow(CAPREVOKE_SHADOW_NOVMMAP, bigblock, oshadow));
+
+	CHERITEST_CHECK_SYSCALL(
+		caprevoke_shadow(CAPREVOKE_SHADOW_INFO_STRUCT, NULL,
+			__DEQUALIFY_CAP(void * __capability *,ocri)));
+}
+
+static void
+test_caprevoke_lib_run(
+	int verbose,
+	int paranoia,
+	size_t bigblock_caps,
+	void * __capability * __capability bigblock,
+	void * __capability shadow,
+	const volatile struct caprevoke_info * __capability cri
+)
+{
+	size_t bigblock_offset = 0;
+
+	while (bigblock_offset < bigblock_caps) {
+		struct caprevoke_stats crst;
+		uint32_t cyc_start, cyc_end;
+
+		size_t csz = rand() % 1024 + 1;
+		csz = MIN(csz, bigblock_caps - bigblock_offset);
+
+		if (verbose > 1) {
+			fprintf(stderr, "left=%zd csz=%zd\n",
+					bigblock_caps - bigblock_offset,
+					csz);
+		}
+
+		void * __capability * __capability chunk =
+			cheri_csetbounds(bigblock + bigblock_offset,
+					 csz * sizeof(void * __capability));
+
+		if (verbose > 1) {
+			CHERI_FPRINT_PTR(stderr, chunk);
+		}
+
+		size_t chunk_offset = bigblock_offset;
+		bigblock_offset += csz;
+
+		if (verbose > 3) {
+			ptrdiff_t fwo, lwo;
+			caprev_shadow_nomap_offsets((vaddr_t)chunk,
+				csz * sizeof(void * __capability), &fwo, &lwo);
+
+			fprintf(stderr,
+				"premrk fwo=%lx lwo=%lx fw=%p "
+				"*fw=%016lx *lw=%016lx\n",
+				fwo, lwo,
+				cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + fwo),
+				*(uint64_t *)(cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + fwo)),
+				*(uint64_t *)(cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + lwo)));
+		}
+
+		/* Mark the chunk for revocation */
+		CHERITEST_VERIFY2(caprev_shadow_nomap_set(shadow, chunk, chunk)
+				  == 0, "Shadow update collision");
+
+		__atomic_thread_fence(__ATOMIC_RELEASE);
+
+		if (verbose > 3) {
+			ptrdiff_t fwo, lwo;
+			caprev_shadow_nomap_offsets((vaddr_t)chunk,
+				csz * sizeof(void * __capability), &fwo, &lwo);
+
+			fprintf(stderr,
+				"marked fwo=%lx lwo=%lx fw=%p "
+				"*fw=%016lx *lw=%016lx\n",
+				fwo, lwo,
+				cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + fwo),
+				*(uint64_t *)(cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + fwo)),
+				*(uint64_t *)(cheri_setaddress(shadow,
+					VM_CAPREVOKE_BM_MEM_NOMAP + lwo)));
+		}
+
+		cyc_start = cheri_get_cyclecount();
+		CHERITEST_CHECK_SYSCALL(
+			caprevoke(CAPREVOKE_LAST_PASS|CAPREVOKE_IGNORE_START,
+					0, &crst));
+		cyc_end = cheri_get_cyclecount();
+		if (verbose > 2) {
+			fprintf_caprevoke_stats(stderr, crst, cyc_end - cyc_start);
+		}
+		CHERITEST_VERIFY2(cri->epoch_dequeue == crst.epoch_fini, "Bad shared clock");
+
+		/* Check the surroundings */
+		if (paranoia > 1) {
+			for (size_t ix = 0; ix < chunk_offset; ix++) {
+				CHERITEST_VERIFY2(!check_revoked(bigblock[ix]),
+						"Revoked cap incorrectly below object, at ix=%zd\n", ix);
+			}
+			for (size_t ix = chunk_offset + csz; ix < bigblock_caps; ix++) {
+				CHERITEST_VERIFY2(!check_revoked(bigblock[ix]),
+						"Revoked cap incorrectly above object, at ix=%zd\n", ix);
+			}
+		}
+
+		for (size_t ix = 0; ix < csz; ix++) {
+			if (paranoia > 0) {
+				if (!check_revoked(chunk[ix])) {
+					CHERI_FPRINT_PTR(stderr, chunk[ix]);
+					cheritest_failure_errx("Unrevoked at ix=%zd after revoke\n", ix);
+				}
+			}
+
+			/* Put it back */
+			chunk[ix] = cheri_andperm(
+					cheri_csetbounds(&chunk[ix], 16),
+					~CHERI_PERM_CHERIABI_VMMAP);
+		}
+
+		caprev_shadow_nomap_clear(shadow, chunk);
+
+		__atomic_thread_fence(__ATOMIC_RELEASE);
+
+	}
+}
+
+void
+test_caprevoke_lib(const struct cheri_test *ctp __unused)
+{
+		/* If debugging the revoker, some verbosity can help. 0 - 4. */
+	static const int verbose = 0;
+
+		/*
+		 * Tweaking paranoia can turn this test into more of a
+		 * benchmark than a correctness test.  At 0, no checks
+		 * will be performed; at 1, only the revoked object is
+		 * investigated, and at 2, the entire allocaton arena
+		 * is tested.
+		 */
+	static const int paranoia = 2;
+
+	static const size_t bigblock_caps = 4096;
+
+	void * __capability * __capability bigblock;
+	void * __capability shadow;
+	const volatile struct caprevoke_info * __capability cri;
+
+	srand(1337);
+
+	test_caprevoke_lib_init(bigblock_caps, &bigblock, &shadow, &cri);
+
+	if (verbose > 0) {
+		CHERI_FPRINT_PTR(stderr, bigblock);
+		CHERI_FPRINT_PTR(stderr, shadow);
+	}
+
+	test_caprevoke_lib_run(verbose, paranoia, bigblock_caps,
+		bigblock, shadow, cri);
+
+	munmap(bigblock, bigblock_caps * sizeof(void * __capability));
+
+	cheritest_success();
+}
+
+void
+test_caprevoke_lib_fork(const struct cheri_test *ctp __unused)
+{
+	static const int verbose = 0;
+	static const int paranoia = 2;
+
+	static const size_t bigblock_caps = 4096;
+
+	void * __capability * __capability bigblock;
+	void * __capability shadow;
+	const volatile struct caprevoke_info * __capability cri;
+
+	int pid;
+
+	srand(1337);
+
+	test_caprevoke_lib_init(bigblock_caps, &bigblock, &shadow, &cri);
+
+	if (verbose > 0) {
+		CHERI_FPRINT_PTR(stderr, bigblock);
+		CHERI_FPRINT_PTR(stderr, shadow);
+	}
+
+	pid = fork();
+	if (pid == 0) {
+		test_caprevoke_lib_run(verbose, paranoia, bigblock_caps,
+			bigblock, shadow, cri);
+	} else {
+		int res;
+
+		CHERITEST_VERIFY2(pid > 0, "fork failed");
+		waitpid(pid, &res, 0);
+		if (res == 0) {
+			cheritest_success();
+		} else {
+			cheritest_failure_errx("Bad child process exit");
+		}
+	}
+
+	munmap(bigblock, bigblock_caps * sizeof(void * __capability));
+
+	cheritest_success();
+}
+
+#endif
